Index: uspace/lib/ui/test/testctl.c
===================================================================
--- uspace/lib/ui/test/testctl.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/ui/test/testctl.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,75 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <pcut/pcut.h>
+#include <ui/control.h>
+#include <ui/testctl.h>
+#include "../private/testctl.h"
+
+PCUT_INIT;
+
+PCUT_TEST_SUITE(testctl);
+
+/** Create and destroy test control */
+PCUT_TEST(create_destroy)
+{
+	ui_test_ctl_t *testctl = NULL;
+	ui_tc_resp_t resp;
+	errno_t rc;
+
+	rc = ui_test_ctl_create(&resp, &testctl);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(testctl);
+
+	ui_test_ctl_destroy(testctl);
+}
+
+/** ui_test_ctl_destroy() can take NULL argument (no-op) */
+PCUT_TEST(destroy_null)
+{
+	ui_test_ctl_destroy(NULL);
+}
+
+/** ui_test_ctl_ctl() returns control that has a working virtual destructor */
+PCUT_TEST(ctl)
+{
+	ui_control_t *control;
+	ui_test_ctl_t *testctl;
+	errno_t rc;
+	ui_tc_resp_t resp;
+
+	rc = ui_test_ctl_create(&resp, &testctl);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	control = ui_test_ctl_ctl(testctl);
+	PCUT_ASSERT_NOT_NULL(control);
+
+	ui_control_destroy(control);
+}
+
+PCUT_EXPORT(testctl);
Index: uspace/lib/ui/test/ui.c
===================================================================
--- uspace/lib/ui/test/ui.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/test/ui.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -69,4 +69,31 @@
 }
 
+/** ui_suspend() / ui_resume() do nothing if we don't have a console,
+ * ui_is_suspended() returns suspend status
+ */
+PCUT_TEST(suspend_resume)
+{
+	ui_t *ui = NULL;
+	errno_t rc;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(ui);
+
+	PCUT_ASSERT_FALSE(ui_is_suspended(ui));
+
+	rc = ui_suspend(ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	PCUT_ASSERT_TRUE(ui_is_suspended(ui));
+
+	rc = ui_resume(ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+
+	PCUT_ASSERT_FALSE(ui_is_suspended(ui));
+
+	ui_destroy(ui);
+}
+
 /** ui_run() / ui_quit() */
 PCUT_TEST(run_quit)
@@ -151,3 +178,37 @@
 }
 
+/** ui_is_get_rect() */
+PCUT_TEST(get_rect)
+{
+	ui_t *ui = NULL;
+	gfx_rect_t rect;
+	errno_t rc;
+
+	rc = ui_create_disp(NULL, &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(ui);
+
+	/* This won't work without a display service */
+	rc = ui_get_rect(ui, &rect);
+	PCUT_ASSERT_ERRNO_VAL(ENOTSUP, rc);
+
+	ui_destroy(ui);
+}
+
+/** ui_lock(), ui_unlock() */
+PCUT_TEST(lock_unlock)
+{
+	ui_t *ui = NULL;
+	errno_t rc;
+
+	rc = ui_create_disp((display_t *)(-1), &ui);
+	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
+	PCUT_ASSERT_NOT_NULL(ui);
+
+	ui_lock(ui);
+	ui_unlock(ui);
+
+	ui_destroy(ui);
+}
+
 PCUT_EXPORT(ui);
